<script setup lang="ts">
import { computed, onMounted } from 'vue';
import { nextTick, ref } from 'vue';
import type { VForm } from "vuetify/components";
import { type User } from '@/types/User'
import type { Salary } from '@/types/Salary'
import { useSalaryStore } from '@/stores/salary'
import { useUserStore } from '@/stores/user'
import user from '@/services/user'
import { useAuthStore } from '@/stores/auth'
import axios from 'axios'

const userStore = useUserStore()
const salaryStore = useSalaryStore()

const salary = ref<Salary[]>([])
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  }, {
    title: 'Name',
    key: 'user_Name',
    value: 'user_Name'
  }, {
    title: 'Bank Account',
    key: 'user_BankAcc',
    value: 'user_BankAcc'
  }, {
    title: 'Salary',
    key: 'salary',
    value: 'salary'
  }, {
    title: 'Bonus',
    key: 'bonus',
    value: 'bonus'
  }, {
    title: 'Net.Salary',
    key: 'netSalary',
    value: 'netSalary'
  },{
        title: 'Status',
        key: 'status',
        value: 'status'
    },
  { title: 'Actions', key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const isEditing = ref(false)
const isAddNew = ref(true)


const initialUser: Salary = {
  id: -1,
  user_Id: -1,
  user_Name: '',
  user_BankAcc: '',
  salary: 0,
  bonus: 0,
  netSalary: 0,
  status: 'Pending',
  payDate: new Date()

}
const editedUser = ref<Salary>(JSON.parse(JSON.stringify(initialUser)))
let editedIndex = -1
let lastId = 4
function onSubmit() {}

function  closeDelete () {
        dialogDelete.value = false
        nextTick(() => {
        editedUser.value = Object.assign({}, initialUser)
        })
    }
function deleteItemConfirm () {
        salary.value.splice(editedIndex, 1)
        closeDelete()
      }
function deleteItem(item:Salary){
    editedIndex = salary.value.indexOf(item)
    editedUser.value = Object.assign({}, item)
    dialogDelete.value = true
    //editedIndex = -1
}      
function editItem(item:Salary){
    editedIndex = salary.value.indexOf(item)
    editedUser.value = Object.assign({}, item)
    dialog.value = true
}
function closeDialog(){
    dialog.value = false
          nextTick(() => {
          editedUser.value = Object.assign({}, initialUser)
          editedIndex = -1
        })
}
async function save(){
    const { valid } = await refForm.value!.validate()
    if (!valid) return
    loading.value = true
    
    // Calculate net salary
    editedUser.value.netSalary = parseFloat(String(editedUser.value.salary)) + parseFloat(String(editedUser.value.bonus));

    if (editedIndex > -1) {
        Object.assign(salary.value[editedIndex], editedUser.value)
    } else {
        editedUser.value.id = lastId++
        salary.value.push(editedUser.value)
    }

    editedIndex = -1
    closeDialog()
    loading.value = false
}  

function initialize() {
  salary.value = [
    {
      id: 1,
      user_Id: -1,
      user_Name: 'Fey BongBong',
      user_BankAcc: '376-2-77854-0',
      salary: 50000,
      bonus: 3000,
      netSalary: 53000,
      status: 'Pending',
      payDate: new Date()

    }, {
      id: 2,
      user_Id: -1,
      user_Name: 'Aom YaYaYing',
      user_BankAcc: '062-8-91223-4',
      salary: 35000,
      bonus: 2000,
      netSalary: 37000,
      status: 'Pending',
      payDate: new Date()




    }, {
      id: 3,
      user_Id: -1,
      user_Name: 'First Sodlor',
      user_BankAcc: '721-2-09213-3',
      salary: 50000,
      bonus: 2000,
      netSalary: 52000,
      status: 'Pending',
      payDate: new Date()



    }, {
      id: 4,
      user_Id: -1,
      user_Name: 'Cros Santa',
      user_BankAcc: '001-3-68543-1',
      salary: 50000,
      bonus: 2000,
      netSalary: 52000,
      status: 'Pending',
      payDate: new Date()



    }, {
      id: 5,
      user_Id: -1,
      user_Name: 'Pop Poppy',
      user_BankAcc: '921-2-43421-3',
      salary: 35000,
      bonus: 4000,
      netSalary: 39000,
      status: 'Paid',
      payDate: new Date()

    }
  ]
}
onMounted(() => {
  save();
  initialize()
})

const paymentSlip = ref('');
const dialogPaymentSlip = ref(false);
let selectedUser = null;

function generatePaymentSlip(item: Salary) {
    if (item.status === "Pending") {
        selectedUser = item;
        selectedUser.status = "Paid";
        const usersDetails = [`${selectedUser.user_Name}`];
        const usersSalary = [`${selectedUser.salary}`];
        const usersNetSalary = [`${selectedUser.netSalary}`];
        const usersAcc = [`${selectedUser.user_BankAcc}`];
        const usersBonus = [`${selectedUser.bonus}`];

        const netSalary = item.salary + item.bonus;
      
         // Format the payment slip
         paymentSlip.value = 
         `Date : ${new Date().toLocaleDateString()}              Payment Successful     
Payment Detail
Bank : Krungthai
Bank Account: ${usersAcc.join('\n')}                           
------------------------------------------------
Username : ${usersDetails.join('\n')}  
------------------------------------------------
Salary : ${usersSalary.join('\n')} ฿
------------------------------------------------
Bonus : ${usersBonus.join('\n')} ฿
Net.Salary : ${usersNetSalary.join('\n')} ฿

`;

// Open the payment slip dialog
dialogPaymentSlip.value = true;
} else {
        // แสดงข้อความว่าไม่พบผู้ใช้ที่มีสถานะ "Paid"
        alert('No user with Paid status found.');
    }
    }

function closePaymentSlipDialog() {
    // Close the payment slip dialog
    dialogPaymentSlip.value = false;
    selectedUser = null;
}

function openPaidSlip() {
    // แสดงหน้าสลิปของผู้ใช้ที่มีสถานะเป็น "Paid"
}

function showPaidSlips() {
    const paidUsers = salary.value.filter(user => user.status === 'Paid');
    if (paidUsers.length > 0) {
        // แสดงสลิปของผู้ใช้ที่มีสถานะเป็น "Paid"
        paidUsers.forEach(user => {
            generatePaymentSlip(user);
        });
    } else {
        // หากไม่มีผู้ใช้ที่มีสถานะเป็น "Paid"
        alert('No users with Paid status found.');
    }
}

    // Save the changes
    save();

</script>

<style scoped>
.actions-column {
  text-align: center;
}
</style>

<template>
  <div>
        <v-data-table :headers="headers" :items="salary">
        <template v-slot:top>
      <v-toolbar
        flat
      >
        <v-toolbar-title>Users</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
    <v-dialog
      v-model="dialog"
      persistent
      width="1024"
    >
      <template v-slot:activator="{ props }">
        <v-btn
          color="primary"
          v-bind="props"
        >
          New Salary
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Salary Info</span>
        </v-card-title>
        <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                    <v-row>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.user_Name"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Name"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.user_BankAcc"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Bank Account"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.salary"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Salary"
                            placeholder="Enter your Salary"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.bonus"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Bonus"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.netSalary"
                            :readonly="loading"
                            

                            class="mb-2"
                            clearable
                            label="Net.Salary"
                              ></v-text-field>
                        </v-col>
                    </v-row>
                
                </v-container>

      </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDialog">Close</v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  
        <!-- Delete Dialog -->
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
        </template>
        <template v-slot:[`item.actions`]="{ item }">
  <v-icon
    color="black blue"
    size="small"
    class="me-2"
    @click="editItem(item)"
  >
    mdi-pencil
  </v-icon>
  <v-icon
    color="red"
    size="small"
    @click="deleteItem(item)"
  >
    mdi-delete
  </v-icon>
  <!-- Payment Slip Dialog -->
  <v-dialog v-model="dialogPaymentSlip" max-width="500px" max-height="1000px">
                    <v-card>
                        <v-card-title class="text-h5 text-center">Pay Slip</v-card-title>
                        <v-card-text>
                            <!-- Display payment slip details here -->
                            <!-- You can format and style the payment slip as needed -->
                            <pre>{{ paymentSlip }}</pre>
                        </v-card-text>

                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="orange" variant="text" @click="closePaymentSlipDialog">
                                Close
                            </v-btn>
                            <v-btn color="orange" variant="text" @click="closePaymentSlipDialog">
                                Print
                            </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
                <v-btn
  :style="{ marginLeft: '8px' }"
  :color="item.status === 'Paid' ? 'green' : 'red'"
  :disabled="item.status === 'Paid'"
  @click="generatePaymentSlip(item)"
  size="small"
>
  Payment
</v-btn>

</template>
    <template v-slot:no-data>
      <v-btn
        color="primary"
        @click="initialize"
      >
        Reset
      </v-btn>
    </template>
        </v-data-table>
    </div>
</template>
